﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;
using System.IO;

namespace DesktopChange01
{
    class RegData
    {
        public static String getUserDesktopPath()
        {
            String _val = "";
            RegistryKey _k = Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", false);

            _val = _k.GetValue("Desktop").ToString();

            _k.Close();

            return _val;
        }

        public static String getAllUsersDesktopPath()
        {
            String _val = "";
            RegistryKey _k = Registry.LocalMachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", false);

            _val = _k.GetValue("Common Desktop").ToString();

            _k.Close();

            return _val;
        }

        public static bool setUserDesktopPath(String _dir)
        {
            if (Directory.Exists(_dir))
            {
                try
                {
                    //1
                    RegistryKey _k1 = Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", true);
                    _k1.SetValue("Desktop", _dir);
                    _k1.Close();
                    //2
                    RegistryKey _k2 = Registry.CurrentUser.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders", true);
                    _k2.SetValue("Desktop", _dir);
                    _k2.Close();

                    return true;
                }
                catch (System.Exception e)
                {
                    return false;
                }
                
            }else{
                return false;
            }
        }

        public static bool setAllUsersDesktopPath(String _dir)
        {
            if (Directory.Exists(_dir))
            {
                try
                {
                    //1
                    RegistryKey _k1 = Registry.LocalMachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", true);
                    _k1.GetValue("Common Desktop", _dir);
                    _k1.Close();
                    //2
                    RegistryKey _k2 = Registry.LocalMachine.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders", true);
                    _k2.GetValue("Common Desktop", _dir);
                    _k2.Close();

                    return true;
                }
                catch (System.Exception e)
                {
                    return false;
                }
                
            }else{
                return false;
            }
        }
    }
}
